#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>

#include "shaperd_config.h"
#include "shaperd_old.h"
#include "read_iplist.h"

extern int	firewall_type;
extern int	shaperd_counter;
extern int	divide_upload;
extern char	output[];
extern char	ipchains_path[];
extern char	iptables_path[];
extern int	squid;
extern int	squid_port;
extern int	extended_queue;
extern int	load_balancing;
extern int	pos_diff;

void add_user_to_firewall(char ***config, struct IPLISTA *ptr, int position)
{
    int		pos;
    char	bufor[1000];
    FILE	*fp;
    char	com[100];

    fflush(NULL);
    sprintf(com,"/bin/sh 2>> %s",output);
    if ((fp = popen(com,"w")))
    {
	if (firewall_type == 1)
	{
	    if ((pos = get_config_by_ip_str(config,ptr)) != -1)
	    {
	        // download
	        sprintf(bufor,"%s -I shaper%d %d -s ! %s -d %s -j RETURN\n",
			ipchains_path,shaperd_counter,position-pos_diff,config[1][(pos*6)+3],ptr -> str_ip);
	        fputs(bufor,fp);
	        if (divide_upload)
	        {
		    int	pos2;

		    if ((pos2 = get_config_by_ip_upload_str(config,ptr)) != -1)
		    {
		        // upload
			sprintf(bufor,"%s -I shaout%d %d -s %s -d ! %s -m %d -j RETURN\n",
			        ipchains_path,shaperd_counter,position-pos_diff,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+position+4);
			fputs(bufor,fp);
		    }
		}
	    }
	}
	else
	if (firewall_type == 2)
	{
	    if ((pos = get_config_by_ip_str(config,ptr)) != -1)
	    {
	        if (squid)
	        {
	            sprintf(bufor,"%s -I squid%d %d -p tcp --src %s --sport %d -m tos --tos 8 --dst %s -j RETURN\n",
			    iptables_path,shaperd_counter,position-pos_diff+2,config[1][(pos*6)+3],squid_port,ptr -> str_ip);
		    fputs(bufor,fp);
		    if (squid==1)
		    {
		    if (extended_queue)
		    {
		        sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
			        iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(position+4)));
			fputs(bufor,fp);
			sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(position+4)));
			fputs(bufor,fp);
		    }
		    else
		    {
		        sprintf(bufor,"%s -A POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(position+4))+(1000*atoi(config[1][(pos*6)+5])));
			fputs(bufor,fp);
			sprintf(bufor,"%s -A POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(position+4))+(1000*atoi(config[1][(pos*6)+5])));
			fputs(bufor,fp);
		    }
		    }
		}
		// download
		if (!load_balancing)
		{
		    sprintf(bufor,"%s -I shaper%d %d -o %s -s ! %s -d %s -j RETURN\n",
			iptables_path,shaperd_counter,position-pos_diff,config[1][(pos*6)+1],config[1][(pos*6)+3],ptr -> str_ip);
		}
		else
		{
		    sprintf(bufor,"%s -I shaper%d %d -s ! %s -d %s -j RETURN\n",
			iptables_path,shaperd_counter,position-pos_diff,config[1][(pos*6)+3],ptr -> str_ip);
		}
		fputs(bufor,fp);
		if (extended_queue)
		{
		    //download
		    // W zaleznoci od pola TOS i adresu docelowego znakujemy pakiety
		    sprintf(bufor,"%s -t mangle -A FORWARD -d %s -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+103+(4*(position+4)));
		    fputs(bufor,fp);
//		    printf("%s\n",bufor);
		    sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+102+(4*(position+4)));
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(position+4)));
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -t mangle -A FORWARD -d %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
		    	    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+100+(4*(position+4)));
		    fputs(bufor,fp);
		}

		if (divide_upload)
		{
		    int	pos2;

		    if ((pos2 = get_config_by_ip_upload_str(config,ptr)) != -1)
		    {
		        // upload
			if (!load_balancing)
			{
		    	    sprintf(bufor,"%s -I shaout%d %d -i %s -s %s -d ! %s -j RETURN\n",
			        iptables_path,shaperd_counter,position,config[1][(pos*6)+1],ptr -> str_ip,config[1][(pos*6)+3]);
			    fputs(bufor,fp);
			}
			else
			{
		    	    sprintf(bufor,"%s -I shaout%d %d -s %s -d ! %s -j RETURN\n",
			        iptables_path,shaperd_counter,position,ptr -> str_ip,config[1][(pos*6)+3]);
			    fputs(bufor,fp);
			}

			if (! extended_queue)
			{
			    sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
			            iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+position+4);
			    fputs(bufor,fp);
			}
			else
			{
			    // upload
			    sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+103+(4*(position+4)));
			    fputs(bufor,fp);
//			    printf("%s\n",bufor);

			    sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
			    	    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+102+(4*(position+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+101+(4*(position+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -t mangle -A FORWARD -s %s -d ! %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+100+(4*(position+4)));
			    fputs(bufor,fp);
			}
		    }
		}
	    }
	}
	fflush(fp);
	pclose(fp);
    }
}

void del_user_from_firewall(char ***config, struct IPLISTA *ptr)
{
    int		pos;
    char	bufor[1000];
    FILE	*fp;
    char	com[100];

    fflush(NULL);

//    printf("del: %d\n",get_ip_cnt(ptr -> str_ip));

    sprintf(com,"/bin/sh 2>> %s",output);
    if ((fp = popen(com,"w")))
    {
	if (firewall_type == 1)
	{
	    if ((pos = get_config_by_ip_str(config,ptr)) != -1)
	    {
	        // download
	        sprintf(bufor,"%s -D shaper%d -s ! %s -d %s -j RETURN\n",
			ipchains_path,shaperd_counter,config[1][(pos*6)+3],ptr -> str_ip);
	        fputs(bufor,fp);
	        if (divide_upload)
	        {
		    int	pos2;

		    if ((pos2 = get_config_by_ip_upload_str(config,ptr)) != -1)
		    {
		        // upload
			sprintf(bufor,"%s -D shaout%d -s %s -d ! %s -m %d -j RETURN\n",
			        ipchains_path,shaperd_counter,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(ptr -> str_ip)+4);
			fputs(bufor,fp);
		    }
		}
	    }
	}
	else
	if (firewall_type == 2)
	{
	    if ((pos = get_config_by_ip_str(config,ptr)) != -1)
	    {
	        if (squid)
	        {
	            sprintf(bufor,"%s -D squid%d -p tcp --src %s --sport %d -m tos --tos 8 --dst %s -j RETURN\n",
			    iptables_path,shaperd_counter,config[1][(pos*6)+3],squid_port,ptr -> str_ip);
		    fputs(bufor,fp);
		    if (squid==1)
		    {
		    if (extended_queue)
		    {
		        sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
			        iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
//			printf("%s\n",bufor);
			sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			fputs(bufor,fp);
		    }
		    else
		    {
		        sprintf(bufor,"%s -D POSTROUTING -t mangle -p tcp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			fputs(bufor,fp);
			sprintf(bufor,"%s -D POSTROUTING -t mangle -p udp --src %s --sport %d --dst %s -m tos --tos 8 -j MARK --set-mark %d\n",
				iptables_path,config[1][(pos*6)+3],squid_port,ptr -> str_ip,(4*(get_ip_cnt(ptr -> str_ip)+4))+(1000*atoi(config[1][(pos*6)+5])));
			fputs(bufor,fp);
		    }
		    }
		}
		// download
		if (!load_balancing)
		{
		    sprintf(bufor,"%s -D shaper%d -o %s -s ! %s -d %s -j RETURN\n",
			iptables_path,shaperd_counter,config[1][(pos*6)+1],config[1][(pos*6)+3],ptr -> str_ip);
		}
		else
		{
		    sprintf(bufor,"%s -D shaper%d -s ! %s -d %s -j RETURN\n",
			iptables_path,shaperd_counter,config[1][(pos*6)+3],ptr -> str_ip);
		}
		fputs(bufor,fp);
		if (extended_queue)
		{
		    //download
		    // W zaleznoci od pola TOS i adresu docelowego znakujemy pakiety
		    sprintf(bufor,"%s -t mangle -D FORWARD -d %s -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
			    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
		    fputs(bufor,fp);
		    sprintf(bufor,"%s -t mangle -D FORWARD -d %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
		    	    iptables_path,ptr -> str_ip,(1000*atoi(config[1][(pos*6)+5]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
		    fputs(bufor,fp);
		}

		if (divide_upload)
		{
		    int	pos2;

		    if ((pos2 = get_config_by_ip_upload_str(config,ptr)) != -1)
		    {
		        // upload
			if (!load_balancing)
			{
		    	    sprintf(bufor,"%s -D shaout%d -i %s -s %s -d ! %s -j RETURN\n",
			        iptables_path,shaperd_counter,config[1][(pos*6)+1],ptr -> str_ip,config[1][(pos*6)+3]);
			}
			else
			{
		    	    sprintf(bufor,"%s -D shaout%d -s %s -d ! %s -j RETURN\n",
			        iptables_path,shaperd_counter,ptr -> str_ip,config[1][(pos*6)+3]);
			}
			fputs(bufor,fp);
			if (! extended_queue)
			{
			    sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
			            iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+get_ip_cnt(ptr -> str_ip)+4);
			    fputs(bufor,fp);
			}
			else
			{
			    // upload
			    sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+103+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);

			    sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -m tos --tos 0x04 -j MARK --set-mark %d\n",
			    	    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+102+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -m tos --tos 0x08 -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+101+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			    sprintf(bufor,"%s -t mangle -D FORWARD -s %s -d ! %s -m tos --tos 0x10 -j MARK --set-mark %d\n",
				    iptables_path,ptr -> str_ip,config[1][(pos*6)+3],(1000*atoi(config[1][(pos2*6)+3]))+100+(4*(get_ip_cnt(ptr -> str_ip)+4)));
			    fputs(bufor,fp);
			}
		    }
		}
	    }
	}
	fflush(fp);
	pclose(fp);
    }
}
